package com.caimei.modules.order.controller;


import com.caimei.modules.order.entity.CmOrderRemark;
import com.caimei.modules.order.service.CmOrderRemarkService;
import com.caimei.utils.JsonModel;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

/**
 * 订单备注Controller
 */
@Controller
@RequestMapping(value = "/order/cmOrderRemark")
public class CmOrderRemarkController {

    @Autowired
    private CmOrderRemarkService cmOrderRemarkService;

    @ModelAttribute
    public CmOrderRemark get(@RequestParam(required = false) String id) {
        CmOrderRemark entity = null;
        if (StringUtils.isNotBlank(id)) {
            entity = cmOrderRemarkService.get(id);
        }
        if (entity == null) {
            entity = new CmOrderRemark();
        }
        return entity;
    }

    //订单备注
    @ResponseBody
    @RequestMapping(value = "remarksView")
    public JsonModel remarksView(Integer orderID) {
        //通过商品ID获取对应备注信息
        CmOrderRemark remark = new CmOrderRemark();
        remark.setOrderID(orderID);
        List<CmOrderRemark> remarksList = cmOrderRemarkService.findList(remark);
        return JsonModel.newInstance().success(remarksList);
    }
}