package com.caimei.modules.products.service.impl;

import com.caimei.modules.club.entity.Page;
import com.caimei.modules.products.dao.CmMallOrganizeProductsDao;
import com.caimei.modules.products.dao.CmMallProductLadderPriceDao;
import com.caimei.modules.products.entity.CmMallOrganizeProducts;
import com.caimei.modules.products.entity.CmMallPageModules;
import com.caimei.modules.products.entity.CmMallProductLadderPrice;
import com.caimei.modules.products.service.CmMallOrganizeProductsService;
import com.caimei.utils.AppUtils;
import com.github.pagehelper.PageHelper;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;

@Service
public class CmMallOrganizeProductsServiceImpl implements CmMallOrganizeProductsService {
    @Resource
    private CmMallOrganizeProductsDao cmMallOrganizeProductsDao;
    @Resource
    private CmMallProductLadderPriceDao cmMallProductLadderPriceDao;
    @Value("${malladmin.domain}")
    private String domain;

    @Override
    public List<CmMallOrganizeProducts> findList(CmMallOrganizeProducts cmMallOrganizeProducts) {
        return cmMallOrganizeProductsDao.findList(cmMallOrganizeProducts);
    }

    @Override
    public Page<CmMallOrganizeProducts> findPage(Page page, CmMallOrganizeProducts cmMallOrganizeProducts) {
        PageHelper.startPage(page.getIndex(), page.getPageSize());
        List<CmMallOrganizeProducts> organizeProductsDaoList = cmMallOrganizeProductsDao.findList(cmMallOrganizeProducts);
        if (CollectionUtils.isNotEmpty(organizeProductsDaoList)) {
            for (CmMallOrganizeProducts c : organizeProductsDaoList) {
                c.setMainImage(AppUtils.getProductImageURL(c.getMainImage(), 0, domain));
                if ("1".equals(c.getLadderPriceFlag())){
                    Long productId = c.getId().longValue();
                    List<CmMallProductLadderPrice> ladderPriceList = cmMallProductLadderPriceDao.selectByProductId(productId);
                    c.setLadderPriceList(ladderPriceList);
                }
            }
        }
        Page<CmMallOrganizeProducts> organizeProductsPage = new Page<>(organizeProductsDaoList);
        return organizeProductsPage;
    }

    @Override
    public List<CmMallPageModules> findAllModule(Integer organizeID) {
        return cmMallOrganizeProductsDao.findAllModule(organizeID);
    }

    @Override
    public void updateProductInfo(CmMallOrganizeProducts cmMallOrganizeProducts, Long userId) {
        cmMallOrganizeProductsDao.updateProductInfo(cmMallOrganizeProducts);
        Long productId = cmMallOrganizeProducts.getId().longValue();
        CmMallProductLadderPrice ladderPrice = new CmMallProductLadderPrice();
        ladderPrice.setProductId(productId);
        ladderPrice.setUpdateBy(userId);
        ladderPrice.setUpdateDate(new Date());
        if("1".equals(cmMallOrganizeProducts.getLadderPriceFlag())) {
            List<CmMallProductLadderPrice> ladderPriceList = cmMallOrganizeProducts.getLadderPriceList();
            for (CmMallProductLadderPrice item: ladderPriceList) {
                ladderPrice.setLadderNum(item.getLadderNum());
                ladderPrice.setBuyNum(item.getBuyNum());
                ladderPrice.setBuyPrice(item.getBuyPrice());
                ladderPrice.setDelFlag(item.getDelFlag());
                Long ladderPriceId = cmMallProductLadderPriceDao.selectIdByProductIdAndLadderNum(productId, item.getLadderNum());
                if (null !=ladderPriceId && ladderPriceId > 0L){
                    ladderPrice.setId(ladderPriceId);
                    cmMallProductLadderPriceDao.updateByPrimaryKeySelective(ladderPrice);
                }else{
                    ladderPrice.setCreateBy(userId);
                    ladderPrice.setCreateDate(new Date());
                    cmMallProductLadderPriceDao.insertSelective(ladderPrice);
                }
            }
        }else{
            List<CmMallProductLadderPrice> ladderPriceList = cmMallProductLadderPriceDao.selectByProductId(productId);
            for (CmMallProductLadderPrice item: ladderPriceList) {
                ladderPrice.setLadderNum(item.getLadderNum());
                ladderPrice.setBuyNum(item.getBuyNum());
                ladderPrice.setBuyPrice(item.getBuyPrice());
                ladderPrice.setDelFlag("1");
                ladderPrice.setId(item.getId());
                cmMallProductLadderPriceDao.updateByPrimaryKeySelective(ladderPrice);
            }
        }
    }

    @Override
    public CmMallOrganizeProducts get(Integer id) {
        return cmMallOrganizeProductsDao.get(id);
    }

    @Override
    public void updateValidFlag(CmMallOrganizeProducts organizeProducts) {
        cmMallOrganizeProductsDao.updateValidFlag(organizeProducts);
    }

    @Override
    public void saveSort(Integer modules, String sort, String id) {
        cmMallOrganizeProductsDao.saveSort(modules, sort, id);
    }

    @Override
    public List<CmMallOrganizeProducts> findListBuyMall(CmMallOrganizeProducts cmMallOrganizeProducts) {
        List<CmMallOrganizeProducts> listBuyMall = cmMallOrganizeProductsDao.findListBuyMall(cmMallOrganizeProducts);
        List<Integer> allExistsProductList = cmMallOrganizeProductsDao.getAllExistsProductList(cmMallOrganizeProducts.getModules());
        if (CollectionUtils.isNotEmpty(listBuyMall)) {
            for (CmMallOrganizeProducts c : listBuyMall) {
                c.setMainImage(AppUtils.getProductImageURL(c.getMainImage(), 0, domain));
                if (CollectionUtils.isNotEmpty(allExistsProductList)) {
                    boolean contains = allExistsProductList.contains(c.getId());
                    if (contains) {
                        c.setExistsFlag("1");
                    }
                }
                if ("1".equals(c.getLadderPriceFlag())){
                    Long productId = c.getId().longValue();
                    List<CmMallProductLadderPrice> ladderPriceList = cmMallProductLadderPriceDao.selectByProductId(productId);
                    c.setLadderPriceList(ladderPriceList);
                }
            }
        }
        return listBuyMall;
    }

    @Override
    public void updateProductInfo1(CmMallOrganizeProducts cop) {
        cmMallOrganizeProductsDao.updateProductInfo1(cop);
    }

    @Override
    public void canncelPreferredProduct(CmMallOrganizeProducts cmMallOrganizeProducts) {
        cmMallOrganizeProductsDao.canncelPreferredProduct(cmMallOrganizeProducts);
    }
}
